;            ͻ
;                  UTILS.ASM        
;                                                               
;                          Useless misc routines                
;            ĺ
;               Auteur Freddy Vtel    
;                                                               
;               Dbut d'criture 03/04/1996       
;               Dernire modification 24/08/1996       
;            ͼ

.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME  CS:CODE32,DS:CODE32,ES:CODE32

INCLUDE OS.INC

INCLUDE UTILS.INC

;=============================================================================
dec_divider dd 1,10,100,1000,10000,100000,1000000,10000000,100000000,1000000000
firstone    db 0

digit   dd 0

Screen_Offset  DD 0
Current_Offset DD 0

;=============================================================================

;͸
;                                                                          
;  print_str: prints a null terminated string (starts at @ESI )            
;                                                                          
;   input: ESI, string start ECX, Max string length                        
;                                                                          
;
Print_Str PROC
        pushad
Print_Strloop:
	mov dl,[esi]
	inc esi
	cmp dl,0
	je Print_strend

ifndef DJGPP
	mov ah,2
        int 21h             	; send character to screen
endif
	
	dec ecx
	jnz Print_strloop
Print_StrEnd:
	popad
        ret
Print_Str ENDP

;͸
;                                                                          
;  print_dec: prints the Decimal value of EAX                              
;                                                                          
;
Print_Dec PROC
        pushad
	mov firstone,0
	mov esi,9
        mov ecx,eax
Print_Decloop:
	cmp esi,-1
	je Print_DecEnd
	mov eax,ecx
        xor edx,edx
        div dec_divider[esi*4]
	dec esi
        mov ecx,edx		; reuse remainder	

	or firstone,al
	cmp firstone,0
	je Print_Decloop

	add al,'0'              ; use quotient as digit number
        mov dl,al

ifndef DJGPP
	mov ah,2
        int 21h             	; send character to screen
endif	
        
        jmp Print_Decloop
Print_DecEnd:
	cmp firstone,0
	jne Print_DecEnd2
	mov dl,'0'

ifndef DJGPP
	mov ah,2
	int 21h
endif	
	
Print_DecEnd2:	
	popad
        ret
Print_Dec ENDP


;͸
;                                                                          
;  print_hex: prints the Decimal value of EAX                              
;                                                                          
;
print_hex   PROC
        pushad
        mov digit,eax
        mov ecx,8
L11:
	rol digit,4
        mov al,byte ptr digit
        and al,0fh
        cmp al,10
    	jb j8
        add al,'A'-'0'-10
j8:     add al,'0'
        mov dl,al

ifndef DJGPP
	mov ah,02h
        int 21h
endif	
        
	loop L11
        popad
        ret
print_hex ENDP

_DPrint_char PROC Near

ifdef DOS32  			     ; ** DOS32 **	
	cmp Screen_Offset,0
	jne _Ok

	pushad
	mov ax,0EE02h                 ; Get DOS32 Address information
        int 31h
        neg ebx                       ; EBX = program address
        add ebx,0b8000h               ; Convert EBX to video memory
	mov Screen_Offset,ebx
	popad
_Ok:
	push ebx
	cmp Current_Offset,4000
	jbe _Screen_Offset_Ok
	mov Current_Offset,0
_Screen_Offset_Ok:	
	mov ebx,Screen_Offset
	add ebx,Current_Offset
	mov [ebx],dl
	add Current_Offset,2
	pop ebx
endif	

ifdef EOS                                  ;** EOS **
	push edi
	cmp Current_Offset,4000
	jbe _Screen_Offset_Ok
	mov Current_Offset,0
_Screen_Offset_Ok:	
	mov edi,Current_Offset
	add edi,[_0b8000h]
	mov [edi],dl
	add Current_Offset,2
	pop edi
endif
	
	ret
_DPrint_char Endp


;͸
;                                                                          
;  Dprint_str: prints a null terminated string (starts at @ESI )           
;                                                                          
;   input: ESI, string start ECX, Max string length                        
;                                                                          
;
_DPrint_Str PROC
        pushad
DPrint_Strloop:
	mov dl,[esi]
	inc esi
	cmp dl,0
	je DPrint_strend

	call _DPrint_char
	
	dec ecx
	jnz DPrint_strloop
DPrint_StrEnd:
	popad
        ret
_DPrint_Str ENDP

;͸
;                                                                          
;  Dprint_dec: prints the Decimal value of EAX                             
;                                                                          
;
_DPrint_Dec PROC
        pushad
	mov firstone,0
	mov esi,9
        mov ecx,eax
DPrint_Decloop:
	cmp esi,-1
	je DPrint_DecEnd
	mov eax,ecx
        xor edx,edx
        div dec_divider[4*esi]
	dec esi
	mov ecx,edx		

	or firstone,al
	cmp firstone,0
	je DPrint_Decloop

	add al,'0'              ; use quotient as digit number
        mov dl,al

	call _Dprint_char
		
        jmp DPrint_Decloop
DPrint_DecEnd:
	cmp firstone,0
	jne DPrint_DecEnd2
	mov dl,'0'

	Call _Dprint_char
	
DPrint_DecEnd2:	
	popad
        ret
_DPrint_Dec ENDP

;͸
;                                                                          
;  Dprint_hex: Direct prints the Decimal value of EAX                      
;                                                                          
;
_Dprint_hex   PROC
        pushad
        mov digit,eax
        mov ecx,8
DL11:
	rol digit,4
        mov al,byte ptr digit
        and al,0fh
        cmp al,10
    	jb Dj8
        add al,'A'-'0'-10
Dj8:    add al,'0'
        mov dl,al

	call _DPrint_Char
		
	loop DL11
        popad
        ret

_Dprint_hex ENDP

CODE32 ENDS
;=============================================================================
end
; UTILS.ASM (c) 1997 FreddyV/Useless