;            ͻ
;                   UPMP.ASM        
;                                                               
;                                USM Play                       
;                             (DOS32 Example)                   
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code starts .................. 13/03/1996       
;               Last Update .................. 01/12/1996       
;            ͼ


.386
.MODEL FLAT
.stack 8*1024

INCLUDE HARDWARE.INC

include XMLOAD.inc

include USMPLAY.inc
include USS.INC
include USSVAR.INC

include GUSDRV.inc
include USM.inc
include MEMORY.inc

include UTILS.inc
include LDEBUG.inc

extrn DEBUG :near              ; Define external symbol

;=============================================================================
.data

Module DB '..\DATA\EFFECT.XM',0

USMOFFSET dd 0

STARTMSG DB 'USM Play v1.0a (DOS32 example).',13,10,36

;=============================================================================
.code

START:
; "Hardware" Init	
	call HardwareInit

; ** Sound system Setup
	
        call USS_Setup
        jc _UPMPEnd
 
; ** Player Start
 
	mov edx,offset StartMsg
        mov ah,9
        int 21H

	Maxavail
	
	WRITE 'Free memory: '
	call PRINT_DEC
	WRITELN ' Byte(s)'

        write 'Device: '

        mov edx,DEV_Name
	mov ah,9
	int 21h

        writeln

	mov esi,offset MODULE
	call XM_LOAD
	jc _UPMPEND

	mov edx,0
	mov USMOFFSET,esi

	call USMP_STARTPLAY

	WRITE 'A key to stop.'
	WAITKEY

	call USMP_STOPPLAY
		
	jmp _UPMPEND
	
_UPMP_MEMORYERR:
	call _MEMORY_Error
	jmp _UPMPEND		

_UPMPEND:
	mov   ax,4C00H
        int   21H
end  START