;            ͻ
;                 USSVAR.ASM        
;                                                               
;                     Useless Sound System 'Variables'          
;            ĺ
;               By Freddy Vtel (FreddyV/Useless)              
;                                                               
;               Code starts .................. 04/04/1996       
;               Last update .................. 09/12/1996       
;            ͼ

.386

CODE32 SEGMENT PUBLIC PARA 'CODE' USE32
ASSUME  CS:CODE32,DS:CODE32,ES:CODE32

;=============================================================================

MAX_CHANNELS EQU 32

Public DEV_Number
Public DEV_Name
Public DEV_BasePort
Public DEV_IRQ
Public DEV_DMA
Public DEV_Freq
Public DEV_Mode
Public DEV_MaxChannels

DEV_Number      DW 0
DEV_Name        DD 0
DEV_BasePort    DW 0
DEV_IRQ         DB 0
DEV_DMA         DB 0
DEV_Freq        DW 0
DEV_Mode        DW 0
DEV_MaxChannels DW 0

Public SSSampleOffsetT
Public SSInstrOffsetT
Public SSLinearPeriode
Public SSInstrumentMode
Public SSGlobalVol
Public SSActiveChannels

SSSampleOffsetT  DD 0   ;Sample Offset Table
SSInstrOffsetT   DD 0   ;Instrument Offset Table
SSLinearPeriode  DB 0
SSInstrumentMode DB 0
SSGlobalVol      DB 0   ;Global Volume (Sound system Volume)
SSActiveChannels DD 32  ;Actual Actives channels

;*** channel definitions ***

Public USSVARStart
Public USSVAREnd

Public VChControl 
Public VChInsAdress
Public VChPeriod
Public VChFreq
Public VChannelVol
Public VChVolume
Public VChFVolume
Public VChPanning
Public VChFPanning
Public VChSmpAdress
Public VChSmpOffset

; ** Instruments var **

Public VChFadeoutVol   
Public VChVolEnvPos    
Public VChVolEnvSegPos 
Public VChEnvVol       
Public VChPanEnvPos    
Public VChPanEnvSegPos 
Public VChEnvPan 

Public VChAVibPos   
Public VChAVibSwpPos
Public VChAVibPitch

Public Period_Table

USSVARStart Label

VChControl   DW MAX_CHANNELS DUP (?)

VChInsAdress DD MAX_CHANNELS DUP (?) ; Instrument definition Adress
VChPeriod    DW MAX_CHANNELS DUP (?) ; Channel Period
VChFreq      DD MAX_CHANNELS DUP (?) ; Channel Final Frequency
VChannelVol  DB MAX_CHANNELS DUP (?) ; Channel Volume
VChVolume    DB MAX_CHANNELS DUP (?) ; Channel Instrument Volume
VChFVolume   DB MAX_CHANNELS DUP (?) ; Channel Final Volume
VChPanning   DB MAX_CHANNELS DUP (?) ; Channel Panning
VChFPanning  DB MAX_CHANNELS DUP (?) ; Channel Final Panning

VChSmpAdress DD MAX_CHANNELS DUP (?) ; Sample definition Adress
VChSmpOffset DD MAX_CHANNELS DUP (?) ; Current Sample Offset (GUS/MIX device)

; ** Instruments var **

VChFadeoutVol   DW MAX_CHANNELS DUP (?)

VChVolEnvPos    DW MAX_CHANNELS DUP (?)
VChVolEnvSegPos DW MAX_CHANNELS DUP (?)
VChEnvVol       DB MAX_CHANNELS DUP (?)

VChPanEnvPos    DW MAX_CHANNELS DUP (?)
VChPanEnvSegPos DW MAX_CHANNELS DUP (?)
VChEnvPan       DB MAX_CHANNELS DUP (?)

VChAVibPos    db MAX_CHANNELS DUP (0)
VChAVibSwpPos db MAX_CHANNELS DUP (0)
VChAVibPitch  dw MAX_CHANNELS DUP (0)

USSVAREnd Label

Period_Table:
;    C                                                                 B      
dw 27392,25856,24384,23040,21696,20480,19328,18240,17216,16256,15360,14496 ;0
dw 13696,12928,12192,11520,10848,10240, 9664, 9120, 8608, 8128, 7680, 7248 ;1
dw  6848, 6464, 6096, 5760, 5424, 5120, 4832, 4560, 4304, 4064, 3840, 3624 ;2
dw  3424, 3232, 3048, 2880, 2712, 2560, 2416, 2280, 2152, 2032, 1920, 1812 ;3
dw  1712, 1616, 1524, 1440, 1356, 1280, 1208, 1140, 1076, 1016,  960,  906 ;4
dw   856,  808,  762,  720,  678,  640,  604,  570,  538,  508,  480,  453 ;5
dw   428,  404,  381,  360,  339,  320,  302,  285,  269,  254,  240,  226 ;6
dw   214,  202,  190,  180,  170,  160,  151,  143,  135,  127,  120,  113 ;7
dw   107,  101,   95,   90,   85,   80,   75,   71,   67,   63,   60,   56 ;8
dw    53,   50,   47,   45,   42,   40,   37,   35,   33,   31,   30,   28 ;9
;dw    26,   25,   23,   22,   21,   20,   18,   17,   16,   15,   15,   14 ;10
dw     0

CODE32 ENDS
;=============================================================================
end
; USSVAR.ASM (c) 1997 FreddyV/Useless